'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
if (!Function.prototype.bind) {
    Function.prototype.bind = function (oThis) {
        if (typeof this !== 'function') {
            // closest thing possible to the ECMAScript 5
            // internal IsCallable function
            throw new TypeError('Function.prototype.bind - what is trying to be bound is not callable');
        }

        var aArgs = Array.prototype.slice.call(arguments, 1),
            fToBind = this,
            fNOP = function fNOP() {},
            fBound = function fBound() {
            return fToBind.apply(this instanceof fNOP ? this : oThis, aArgs.concat(Array.prototype.slice.call(arguments)));
        };

        if (this.prototype) {
            // native functions don't have a prototype
            fNOP.prototype = this.prototype;
        }
        fBound.prototype = new fNOP();

        return fBound;
    };
}

var global = typeof window !== 'undefined' ? window : undefined;

var console = global.console || {};

if (console["log"] !== 'function') {
    console["log"] = function () {};
}

if (typeof console["info"] !== 'function') {
    console["info"] = console["log"];
}

if (typeof console["error"] !== 'function') {
    console["error"] = console["log"];
}

var consoleInfo = exports.consoleInfo = console.info.bind(console);
var consoleError = exports.consoleError = console.error.bind(console);