"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Events = (function () {
    function Events() {
        _classCallCheck(this, Events);

        this._events = new Map();
    }

    _createClass(Events, [{
        key: "on",
        value: function on(type, handler) {
            var _this = this;

            var currentHandlers = this._events.get(type) || [];
            var handlers = currentHandlers.concat([handler]);
            this._events.set(type, handlers);
            return function () {
                return _this.off(type, handler);
            };
        }
    }, {
        key: "off",
        value: function off(type, handler) {
            if (typeof handler !== "undefined") {
                if (this._events.has(type)) {
                    var currentHandlers = this._events.get(type);
                    this._events.set(type, currentHandlers.filter(function (item) {
                        return item !== handler;
                    }));
                }
            } else {
                this._events.delete(type);
            }
        }
    }, {
        key: "trigger",
        value: function trigger(type, obj) {
            for (var _len = arguments.length, args = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
                args[_key - 2] = arguments[_key];
            }

            if (this._events.has(type)) {
                this._events.get(type).forEach(function (handler) {
                    return handler.call.apply(handler, [obj].concat(args));
                });
            }
        }
    }]);

    return Events;
})();

exports.default = Events;